package edu.berkeley.eecs.openwsn.server;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import edu.berkeley.eecs.openwsn.shared.NetworkStats;
/**
 * 
 * @author Xavi Vilajosana
 *
 */
public class DomainController {
	public class Alarm {
		public Alarm(Integer minimum, Integer maximum) { 
			this.minimum = minimum; 
			this.maximum = maximum;
		}
		public Integer minimum;
		public Integer maximum;
	}
	
	public static DomainController instance;//singleton
	public HashMap<Long,NetworkStats> netstats;
	public Alarm temperatureAlarm;
	public Alarm humidityAlarm;
	public Integer interval;
	public String email;
	
	public DomainController(){
		super();
		if (instance==null){
			instance=this;
			netstats=new HashMap<Long, NetworkStats>();
			temperatureAlarm = new Alarm(0, 40);
			humidityAlarm = new Alarm(20, 80);
			interval = 5;
			email = "jefernandez@uoc.edu";
		}
	}
	
	public static DomainController getInstance(){
		if (instance==null) {
			instance=new DomainController();
			instance.netstats=new HashMap<Long, NetworkStats>();
			instance.temperatureAlarm = instance.new Alarm(0, 40);
			instance.humidityAlarm = instance.new Alarm(20, 80);
			instance.interval = 5;
			instance.email = "jefernandez@uoc.edu";
		}
		return instance;
	}
	
	public NetworkStats getNetworkStats(Long id){
		if (netstats.get(id)!=null){
			return netstats.get(id);
		}else{
			return null;
		}
	}
	
	public NetworkStats addNetworkStats(Long id){
		if (netstats.get(id)!=null){
			//do nothing. it already exists
		}else{
			netstats.put(id, new NetworkStats(id));
			
		}
		return netstats.get(id);
	}
	
	
	public void resetAll(){
		this.netstats.clear();
	}

	public List<Long> getListOfNetworks() {
		
		return new ArrayList<Long>(this.netstats.keySet());
	}
	

}
