package edu.berkeley.eecs.openwsn.server;

import java.util.Random;

import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Request;
import javax.ws.rs.core.UriInfo;

/**
 * 
 * @author Xavi Vilajosana
 *
 */
@Path("/feed")
public class GetFeed {
	@Context
	UriInfo uriInfo;

	@Context
	Request request;
	
	protected Integer GetInterval() {
		return DomainController.getInstance().interval;
	}
	
	protected Integer GetTemperatureMax() {
		return DomainController.getInstance().temperatureAlarm.maximum;
	}
	
	protected Integer GetTemperatureMin() {
		return DomainController.getInstance().temperatureAlarm.minimum;
	}
	
	protected Integer GetHumidityMax() {
		return DomainController.getInstance().humidityAlarm.maximum;
	}
	
	protected Integer GetHumidityMin() {
		return DomainController.getInstance().humidityAlarm.minimum;
	}

	// This method is called if TEXT_PLAIN is request
	@GET
	@Produces(MediaType.TEXT_PLAIN)
	public String getFeedPlain() {
		String data = new String();
		
		data += "Interval: " + GetInterval() + "\n";
		data += "TempMax: " + GetTemperatureMax() + "\n";
		data += "TempMin: " + GetTemperatureMin() + "\n";
		data += "HumiMax: " + GetHumidityMax() + "\n";
		data += "HumiMin: " + GetHumidityMin() + "\n";

		return data;
	}

	// This method is called if XML is request
	/*@GET
	@Produces(MediaType.TEXT_XML)
	public String getFeedXML() {
		String xml = new String();
		xml += "<?xml version=\"1.0\"?>";
		xml += "<config>\n";
		xml += "\t<interval>" + GetInterval() + "</interval>";
		xml += "\t<tempmax>" + GetTemperatureMax() + "</tempmax>";
		xml += "\t<tempmin>" + GetTemperatureMin() + "</tempmin>";
		xml += "\t<humimax>" + GetHumidityMax() + "</humimax>";
		xml += "\t<humimin>" + GetHumidityMin() + "</humimin>";
		xml += "</config>";
		return xml;
	}*/

	// This method is called if HTML is request
	@GET
	@Produces(MediaType.TEXT_HTML)
	public String getFeedHtml() {
		return "<html> " + "<title>" + "Current Config" + "</title>"
		+ "<body><h1>" 
		+ "Interval: " + GetInterval() + "<br>"
		+ "TempMax: " + GetTemperatureMax() + "<br>"
		+ "TempMin: " + GetTemperatureMin() + "<br>"
		+ "HumiMax: " + GetHumidityMax() + "<br>"
		+ "HumiMin: " + GetHumidityMin()
		+ "</h1></body>" + "</html> ";
	}


}
