/**
 * @file sht1x.h
 * @brief Cabecerda del driver SHT1X.
 */
#ifndef SHT1X_H_
#define SHT1X_H_

#include <stdint.h>

/// Unidad de temperatura.
typedef enum _SHT1X_TemperatureUnit {
	/// Celsius.
	SHT1X_Celsius = 0,
	/// Kelvin.
	SHT1X_Kelvin,
	/// Fahrenheit.
	SHT1X_Fahrenheit
} SHT1X_TemperatureUnit;

void SHT1X_Initialize(uint8_t sckPin, uint8_t dataPin);
float SHT1X_ReadTemperature(SHT1X_TemperatureUnit unit);
float SHT1X_ReadRelativeHumidity(float temperature);

#endif /* SHT1X_H_ */
