/**
 * @file wifly.h
 * @brief Cabecera del driver WIFLY.
 */
#ifndef WIFLYLIB_H_
#define WIFLYLIB_H_

#include <stdint.h>
#include <stdbool.h>

typedef enum _WIFLY_SecurityType {
    WIFLY_ST_WEP = 0,
    WIFLY_ST_WPA,
    WIFLY_ST_WPA2 = WIFLY_ST_WPA
} WIFLY_SecurityType;

bool WIFLY_Initialize(uint32_t uartId);
bool WIFLY_ConnectToWLAN(const char* ssid, WIFLY_SecurityType secType,
                         const char* password);
uint32_t WIFLY_Ping(char *address);
uint32_t WIFLY_GetIP();
uint8_t WIFLY_GetChannel();
int8_t WIFLY_GetRSSI();
uint32_t WIFLY_GetUptime();
uint8_t WIFLY_GetTxPower();
bool WIFLY_SetTxPower(uint8_t value);
bool WIFLY_Open(char *address, uint32_t port, uint8_t format,
		const char *remote);
void WIFLY_Close(bool waitForClose);
void WIFLY_Sleep();

#endif /* WIFLYLIB_H_ */
